/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Net.Mime;
using Coscine.ApiClient.Core.Client;
using Coscine.ApiClient.Core.Model;

namespace Coscine.ApiClient.Core.Api
{

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IPidApiSync : IApiAccessor
    {
        #region Synchronous Operations
        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        void ApiV2PidsOptions(int operationIndex = 0);

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> ApiV2PidsOptionsWithHttpInfo(int operationIndex = 0);
        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>PidDtoResponse</returns>
        PidDtoResponse GetPid(string prefix, Guid suffix, int operationIndex = 0);

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of PidDtoResponse</returns>
        ApiResponse<PidDtoResponse> GetPidWithHttpInfo(string prefix, Guid suffix, int operationIndex = 0);
        /// <summary>
        /// Retrieves all PIDs.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>PidDtoPagedResponse</returns>
        PidDtoPagedResponse GetPids(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0);

        /// <summary>
        /// Retrieves all PIDs.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of PidDtoPagedResponse</returns>
        ApiResponse<PidDtoPagedResponse> GetPidsWithHttpInfo(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0);
        /// <summary>
        /// Sends an inquiry to the owner of the given PID.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        void SendRequestToOwner(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0);

        /// <summary>
        /// Sends an inquiry to the owner of the given PID.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        ApiResponse<Object> SendRequestToOwnerWithHttpInfo(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0);
        #endregion Synchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IPidApiAsync : IApiAccessor
    {
        #region Asynchronous Operations
        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task ApiV2PidsOptionsAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint.
        /// </summary>
        /// <remarks>
        /// 
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> ApiV2PidsOptionsWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of PidDtoResponse</returns>
        System.Threading.Tasks.Task<PidDtoResponse> GetPidAsync(string prefix, Guid suffix, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (PidDtoResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<PidDtoResponse>> GetPidWithHttpInfoAsync(string prefix, Guid suffix, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Retrieves all PIDs.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of PidDtoPagedResponse</returns>
        System.Threading.Tasks.Task<PidDtoPagedResponse> GetPidsAsync(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Retrieves all PIDs.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (PidDtoPagedResponse)</returns>
        System.Threading.Tasks.Task<ApiResponse<PidDtoPagedResponse>> GetPidsWithHttpInfoAsync(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        /// <summary>
        /// Sends an inquiry to the owner of the given PID.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        System.Threading.Tasks.Task SendRequestToOwnerAsync(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));

        /// <summary>
        /// Sends an inquiry to the owner of the given PID.
        /// </summary>
        /// <remarks>
        /// &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </remarks>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        System.Threading.Tasks.Task<ApiResponse<Object>> SendRequestToOwnerWithHttpInfoAsync(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken));
        #endregion Asynchronous Operations
    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public interface IPidApi : IPidApiSync, IPidApiAsync
    {

    }

    /// <summary>
    /// Represents a collection of functions to interact with the API endpoints
    /// </summary>
    public partial class PidApi : IPidApi
    {
        private Coscine.ApiClient.Core.Client.ExceptionFactory _exceptionFactory = (name, response) => null;

        /// <summary>
        /// Initializes a new instance of the <see cref="PidApi"/> class.
        /// </summary>
        /// <returns></returns>
        public PidApi() : this((string)null)
        {
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PidApi"/> class.
        /// </summary>
        /// <returns></returns>
        public PidApi(string basePath)
        {
            this.Configuration = Coscine.ApiClient.Core.Client.Configuration.MergeConfigurations(
                Coscine.ApiClient.Core.Client.GlobalConfiguration.Instance,
                new Coscine.ApiClient.Core.Client.Configuration { BasePath = basePath }
            );
            this.Client = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PidApi"/> class
        /// using Configuration object
        /// </summary>
        /// <param name="configuration">An instance of Configuration</param>
        /// <returns></returns>
        public PidApi(Coscine.ApiClient.Core.Client.Configuration configuration)
        {
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Configuration = Coscine.ApiClient.Core.Client.Configuration.MergeConfigurations(
                Coscine.ApiClient.Core.Client.GlobalConfiguration.Instance,
                configuration
            );
            this.Client = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            this.AsynchronousClient = new Coscine.ApiClient.Core.Client.ApiClient(this.Configuration.BasePath);
            ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// Initializes a new instance of the <see cref="PidApi"/> class
        /// using a Configuration object and client instance.
        /// </summary>
        /// <param name="client">The client interface for synchronous API access.</param>
        /// <param name="asyncClient">The client interface for asynchronous API access.</param>
        /// <param name="configuration">The configuration object.</param>
        public PidApi(Coscine.ApiClient.Core.Client.ISynchronousClient client, Coscine.ApiClient.Core.Client.IAsynchronousClient asyncClient, Coscine.ApiClient.Core.Client.IReadableConfiguration configuration)
        {
            if (client == null) throw new ArgumentNullException("client");
            if (asyncClient == null) throw new ArgumentNullException("asyncClient");
            if (configuration == null) throw new ArgumentNullException("configuration");

            this.Client = client;
            this.AsynchronousClient = asyncClient;
            this.Configuration = configuration;
            this.ExceptionFactory = Coscine.ApiClient.Core.Client.Configuration.DefaultExceptionFactory;
        }

        /// <summary>
        /// The client for accessing this underlying API asynchronously.
        /// </summary>
        public Coscine.ApiClient.Core.Client.IAsynchronousClient AsynchronousClient { get; set; }

        /// <summary>
        /// The client for accessing this underlying API synchronously.
        /// </summary>
        public Coscine.ApiClient.Core.Client.ISynchronousClient Client { get; set; }

        /// <summary>
        /// Gets the base path of the API client.
        /// </summary>
        /// <value>The base path</value>
        public string GetBasePath()
        {
            return this.Configuration.BasePath;
        }

        /// <summary>
        /// Gets or sets the configuration object
        /// </summary>
        /// <value>An instance of the Configuration</value>
        public Coscine.ApiClient.Core.Client.IReadableConfiguration Configuration { get; set; }

        /// <summary>
        /// Provides a factory method hook for the creation of exceptions.
        /// </summary>
        public Coscine.ApiClient.Core.Client.ExceptionFactory ExceptionFactory
        {
            get
            {
                if (_exceptionFactory != null && _exceptionFactory.GetInvocationList().Length > 1)
                {
                    throw new InvalidOperationException("Multicast delegate for ExceptionFactory is unsupported.");
                }
                return _exceptionFactory;
            }
            set { _exceptionFactory = value; }
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        public void ApiV2PidsOptions(int operationIndex = 0)
        {
            ApiV2PidsOptionsWithHttpInfo();
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<Object> ApiV2PidsOptionsWithHttpInfo(int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "PidApi.ApiV2PidsOptions";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Options<Object>("/api/v2/pids", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiV2PidsOptions", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task ApiV2PidsOptionsAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            await ApiV2PidsOptionsWithHttpInfoAsync(operationIndex, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Responds with the HTTP methods allowed for the endpoint. 
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<Object>> ApiV2PidsOptionsWithHttpInfoAsync(int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }


            localVarRequestOptions.Operation = "PidApi.ApiV2PidsOptions";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.OptionsAsync<Object>("/api/v2/pids", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("ApiV2PidsOptions", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>PidDtoResponse</returns>
        public PidDtoResponse GetPid(string prefix, Guid suffix, int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<PidDtoResponse> localVarResponse = GetPidWithHttpInfo(prefix, suffix);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of PidDtoResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<PidDtoResponse> GetPidWithHttpInfo(string prefix, Guid suffix, int operationIndex = 0)
        {
            // verify the required parameter 'prefix' is set
            if (prefix == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'prefix' when calling PidApi->GetPid");
            }

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("prefix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(prefix)); // path parameter
            localVarRequestOptions.PathParameters.Add("suffix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(suffix)); // path parameter

            localVarRequestOptions.Operation = "PidApi.GetPid";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<PidDtoResponse>("/api/v2/pids/{prefix}/{suffix}", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetPid", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of PidDtoResponse</returns>
        public async System.Threading.Tasks.Task<PidDtoResponse> GetPidAsync(string prefix, Guid suffix, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<PidDtoResponse> localVarResponse = await GetPidWithHttpInfoAsync(prefix, suffix, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves the Persistent Identifier (PID) for a given prefix and suffix. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix. Limited to the values provided by the API.</param>
        /// <param name="suffix">The PID suffix of a project or a resource, represented as a GUID.</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (PidDtoResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<PidDtoResponse>> GetPidWithHttpInfoAsync(string prefix, Guid suffix, int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'prefix' is set
            if (prefix == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'prefix' when calling PidApi->GetPid");
            }


            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("prefix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(prefix)); // path parameter
            localVarRequestOptions.PathParameters.Add("suffix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(suffix)); // path parameter

            localVarRequestOptions.Operation = "PidApi.GetPid";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<PidDtoResponse>("/api/v2/pids/{prefix}/{suffix}", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetPid", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all PIDs. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>PidDtoPagedResponse</returns>
        public PidDtoPagedResponse GetPids(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.ApiResponse<PidDtoPagedResponse> localVarResponse = GetPidsWithHttpInfo(includeProjects, includeResources, includeDeleted, pageNumber, pageSize, orderBy);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all PIDs. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of PidDtoPagedResponse</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<PidDtoPagedResponse> GetPidsWithHttpInfo(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0)
        {
            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (includeProjects != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeProjects", includeProjects));
            }
            if (includeResources != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeResources", includeResources));
            }
            if (includeDeleted != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeDeleted", includeDeleted));
            }
            if (pageNumber != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "PageNumber", pageNumber));
            }
            if (pageSize != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "PageSize", pageSize));
            }
            if (orderBy != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "OrderBy", orderBy));
            }

            localVarRequestOptions.Operation = "PidApi.GetPids";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Get<PidDtoPagedResponse>("/api/v2/pids", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetPids", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Retrieves all PIDs. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of PidDtoPagedResponse</returns>
        public async System.Threading.Tasks.Task<PidDtoPagedResponse> GetPidsAsync(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            Coscine.ApiClient.Core.Client.ApiResponse<PidDtoPagedResponse> localVarResponse = await GetPidsWithHttpInfoAsync(includeProjects, includeResources, includeDeleted, pageNumber, pageSize, orderBy, operationIndex, cancellationToken).ConfigureAwait(false);
            return localVarResponse.Data;
        }

        /// <summary>
        /// Retrieves all PIDs. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;administrator&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="includeProjects">Gets or sets a value indicating whether to include projects when retrieving pid information. (optional)</param>
        /// <param name="includeResources">Gets or sets a value indicating whether to include resources when retrieving pid information. (optional)</param>
        /// <param name="includeDeleted">Gets or sets a value indicating whether to include deleted pid information. (optional)</param>
        /// <param name="pageNumber">The desired page number. Should be greater than or equal to 1. Default is 1. (optional)</param>
        /// <param name="pageSize">The desired page size. Should be between 1 and the maximum allowed page size (50). Default is 10. (optional)</param>
        /// <param name="orderBy">Gets or sets the field name used for ordering the results.  The order is constructed by a order string.  Use the property followed by \&quot;asc\&quot; or \&quot;desc\&quot; and separate properties by commas. Default is asc. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse (PidDtoPagedResponse)</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<PidDtoPagedResponse>> GetPidsWithHttpInfoAsync(bool? includeProjects = default(bool?), bool? includeResources = default(bool?), bool? includeDeleted = default(bool?), int? pageNumber = default(int?), int? pageSize = default(int?), string? orderBy = default(string?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
                "application/json",
                "text/json"
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            if (includeProjects != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeProjects", includeProjects));
            }
            if (includeResources != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeResources", includeResources));
            }
            if (includeDeleted != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "IncludeDeleted", includeDeleted));
            }
            if (pageNumber != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "PageNumber", pageNumber));
            }
            if (pageSize != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "PageSize", pageSize));
            }
            if (orderBy != null)
            {
                localVarRequestOptions.QueryParameters.Add(Coscine.ApiClient.Core.Client.ClientUtils.ParameterToMultiMap("", "OrderBy", orderBy));
            }

            localVarRequestOptions.Operation = "PidApi.GetPids";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.GetAsync<PidDtoPagedResponse>("/api/v2/pids", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("GetPids", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Sends an inquiry to the owner of the given PID. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns></returns>
        public void SendRequestToOwner(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0)
        {
            SendRequestToOwnerWithHttpInfo(prefix, suffix, pidRequestDto);
        }

        /// <summary>
        /// Sends an inquiry to the owner of the given PID. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <returns>ApiResponse of Object(void)</returns>
        public Coscine.ApiClient.Core.Client.ApiResponse<Object> SendRequestToOwnerWithHttpInfo(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0)
        {
            // verify the required parameter 'prefix' is set
            if (prefix == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'prefix' when calling PidApi->SendRequestToOwner");
            }

            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
                "application/json",
                "text/json",
                "application/*+json"
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("prefix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(prefix)); // path parameter
            localVarRequestOptions.PathParameters.Add("suffix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(suffix)); // path parameter
            localVarRequestOptions.Data = pidRequestDto;

            localVarRequestOptions.Operation = "PidApi.SendRequestToOwner";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = this.Client.Post<Object>("/api/v2/pids/{prefix}/{suffix}/requests", localVarRequestOptions, this.Configuration);
            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SendRequestToOwner", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

        /// <summary>
        /// Sends an inquiry to the owner of the given PID. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of void</returns>
        public async System.Threading.Tasks.Task SendRequestToOwnerAsync(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            await SendRequestToOwnerWithHttpInfoAsync(prefix, suffix, pidRequestDto, operationIndex, cancellationToken).ConfigureAwait(false);
        }

        /// <summary>
        /// Sends an inquiry to the owner of the given PID. &lt;p&gt;&lt;strong&gt;Required JWT roles for access:&lt;/strong&gt; &lt;code&gt;&lt;/code&gt;.&lt;/p&gt;
        /// </summary>
        /// <exception cref="Coscine.ApiClient.Core.Client.ApiException">Thrown when fails to make API call</exception>
        /// <param name="prefix">The PID prefix of a project or a resource to validate</param>
        /// <param name="suffix">The PID body of a project or a resource to validate</param>
        /// <param name="pidRequestDto">The data transfer object containing the inquiry details. (optional)</param>
        /// <param name="operationIndex">Index associated with the operation.</param>
        /// <param name="cancellationToken">Cancellation Token to cancel the request.</param>
        /// <returns>Task of ApiResponse</returns>
        public async System.Threading.Tasks.Task<Coscine.ApiClient.Core.Client.ApiResponse<Object>> SendRequestToOwnerWithHttpInfoAsync(string prefix, Guid suffix, PidRequestDto? pidRequestDto = default(PidRequestDto?), int operationIndex = 0, System.Threading.CancellationToken cancellationToken = default(System.Threading.CancellationToken))
        {
            // verify the required parameter 'prefix' is set
            if (prefix == null)
            {
                throw new Coscine.ApiClient.Core.Client.ApiException(400, "Missing required parameter 'prefix' when calling PidApi->SendRequestToOwner");
            }


            Coscine.ApiClient.Core.Client.RequestOptions localVarRequestOptions = new Coscine.ApiClient.Core.Client.RequestOptions();

            string[] _contentTypes = new string[] {
                "application/json", 
                "text/json", 
                "application/*+json"
            };

            // to determine the Accept header
            string[] _accepts = new string[] {
            };

            var localVarContentType = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderContentType(_contentTypes);
            if (localVarContentType != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Content-Type", localVarContentType);
            }

            var localVarAccept = Coscine.ApiClient.Core.Client.ClientUtils.SelectHeaderAccept(_accepts);
            if (localVarAccept != null)
            {
                localVarRequestOptions.HeaderParameters.Add("Accept", localVarAccept);
            }

            localVarRequestOptions.PathParameters.Add("prefix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(prefix)); // path parameter
            localVarRequestOptions.PathParameters.Add("suffix", Coscine.ApiClient.Core.Client.ClientUtils.ParameterToString(suffix)); // path parameter
            localVarRequestOptions.Data = pidRequestDto;

            localVarRequestOptions.Operation = "PidApi.SendRequestToOwner";
            localVarRequestOptions.OperationIndex = operationIndex;

            // authentication (Bearer) required
            if (!string.IsNullOrEmpty(this.Configuration.GetApiKeyWithPrefix("Authorization")))
            {
                localVarRequestOptions.HeaderParameters.Add("Authorization", this.Configuration.GetApiKeyWithPrefix("Authorization"));
            }

            // make the HTTP request
            var localVarResponse = await this.AsynchronousClient.PostAsync<Object>("/api/v2/pids/{prefix}/{suffix}/requests", localVarRequestOptions, this.Configuration, cancellationToken).ConfigureAwait(false);

            if (this.ExceptionFactory != null)
            {
                Exception _exception = this.ExceptionFactory("SendRequestToOwner", localVarResponse);
                if (_exception != null)
                {
                    throw _exception;
                }
            }

            return localVarResponse;
        }

    }
}
