/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for a file within a tree structure, extending the base TreeDto.
    /// </summary>
    [DataContract(Name = "FileTreeDto")]
    public partial class FileTreeDto : IEquatable<FileTreeDto>, IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public TreeDataType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="FileTreeDto" /> class.
        /// </summary>
        /// <param name="path">The path of the tree item..</param>
        /// <param name="type">type.</param>
        /// <param name="directory">Gets or sets the directory of the file..</param>
        /// <param name="name">Gets or sets the name of the file..</param>
        /// <param name="extension">Gets or sets the extension of the file..</param>
        /// <param name="size">Gets or sets the size of the file in bytes..</param>
        /// <param name="creationDate">Gets or sets the creation date of the file..</param>
        /// <param name="changeDate">Gets or sets the last change date of the file..</param>
        /// <param name="actions">actions.</param>
        /// <param name="hidden">Determines if the specific tree entry is hidden..</param>
        public FileTreeDto(string path = default(string), TreeDataType? type = default(TreeDataType?), string directory = default(string), string name = default(string), string extension = default(string), long size = default(long), DateTime? creationDate = default(DateTime?), DateTime? changeDate = default(DateTime?), FileActionsDto actions = default(FileActionsDto), bool hidden = default(bool))
        {
            this.Path = path;
            this.Type = type;
            this.Directory = directory;
            this.Name = name;
            this.Extension = extension;
            this.Size = size;
            this.CreationDate = creationDate;
            this.ChangeDate = changeDate;
            this.Actions = actions;
            this.Hidden = hidden;
        }

        /// <summary>
        /// The path of the tree item.
        /// </summary>
        /// <value>The path of the tree item.</value>
        [DataMember(Name = "path", EmitDefaultValue = false)]
        public string Path { get; set; }

        /// <summary>
        /// Gets or sets the directory of the file.
        /// </summary>
        /// <value>Gets or sets the directory of the file.</value>
        [DataMember(Name = "directory", EmitDefaultValue = false)]
        public string Directory { get; set; }

        /// <summary>
        /// Gets or sets the name of the file.
        /// </summary>
        /// <value>Gets or sets the name of the file.</value>
        [DataMember(Name = "name", EmitDefaultValue = false)]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the extension of the file.
        /// </summary>
        /// <value>Gets or sets the extension of the file.</value>
        [DataMember(Name = "extension", EmitDefaultValue = false)]
        public string Extension { get; set; }

        /// <summary>
        /// Gets or sets the size of the file in bytes.
        /// </summary>
        /// <value>Gets or sets the size of the file in bytes.</value>
        [DataMember(Name = "size", EmitDefaultValue = false)]
        public long Size { get; set; }

        /// <summary>
        /// Gets or sets the creation date of the file.
        /// </summary>
        /// <value>Gets or sets the creation date of the file.</value>
        [DataMember(Name = "creationDate", EmitDefaultValue = true)]
        public DateTime? CreationDate { get; set; }

        /// <summary>
        /// Gets or sets the last change date of the file.
        /// </summary>
        /// <value>Gets or sets the last change date of the file.</value>
        [DataMember(Name = "changeDate", EmitDefaultValue = true)]
        public DateTime? ChangeDate { get; set; }

        /// <summary>
        /// Gets or Sets Actions
        /// </summary>
        [DataMember(Name = "actions", EmitDefaultValue = false)]
        public FileActionsDto Actions { get; set; }

        /// <summary>
        /// Determines if the specific tree entry is hidden.
        /// </summary>
        /// <value>Determines if the specific tree entry is hidden.</value>
        [DataMember(Name = "hidden", EmitDefaultValue = true)]
        public bool Hidden { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class FileTreeDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Directory: ").Append(Directory).Append("\n");
            sb.Append("  Name: ").Append(Name).Append("\n");
            sb.Append("  Extension: ").Append(Extension).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("  CreationDate: ").Append(CreationDate).Append("\n");
            sb.Append("  ChangeDate: ").Append(ChangeDate).Append("\n");
            sb.Append("  Actions: ").Append(Actions).Append("\n");
            sb.Append("  Hidden: ").Append(Hidden).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FileTreeDto);
        }

        /// <summary>
        /// Returns true if FileTreeDto instances are equal
        /// </summary>
        /// <param name="input">Instance of FileTreeDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FileTreeDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Path == input.Path ||
                    (this.Path != null &&
                    this.Path.Equals(input.Path))
                ) && 
                (
                    this.Type == input.Type ||
                    this.Type.Equals(input.Type)
                ) && 
                (
                    this.Directory == input.Directory ||
                    (this.Directory != null &&
                    this.Directory.Equals(input.Directory))
                ) && 
                (
                    this.Name == input.Name ||
                    (this.Name != null &&
                    this.Name.Equals(input.Name))
                ) && 
                (
                    this.Extension == input.Extension ||
                    (this.Extension != null &&
                    this.Extension.Equals(input.Extension))
                ) && 
                (
                    this.Size == input.Size ||
                    this.Size.Equals(input.Size)
                ) && 
                (
                    this.CreationDate == input.CreationDate ||
                    (this.CreationDate != null &&
                    this.CreationDate.Equals(input.CreationDate))
                ) && 
                (
                    this.ChangeDate == input.ChangeDate ||
                    (this.ChangeDate != null &&
                    this.ChangeDate.Equals(input.ChangeDate))
                ) && 
                (
                    this.Actions == input.Actions ||
                    (this.Actions != null &&
                    this.Actions.Equals(input.Actions))
                ) && 
                (
                    this.Hidden == input.Hidden ||
                    this.Hidden.Equals(input.Hidden)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Path != null)
                {
                    hashCode = (hashCode * 59) + this.Path.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Type.GetHashCode();
                if (this.Directory != null)
                {
                    hashCode = (hashCode * 59) + this.Directory.GetHashCode();
                }
                if (this.Name != null)
                {
                    hashCode = (hashCode * 59) + this.Name.GetHashCode();
                }
                if (this.Extension != null)
                {
                    hashCode = (hashCode * 59) + this.Extension.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Size.GetHashCode();
                if (this.CreationDate != null)
                {
                    hashCode = (hashCode * 59) + this.CreationDate.GetHashCode();
                }
                if (this.ChangeDate != null)
                {
                    hashCode = (hashCode * 59) + this.ChangeDate.GetHashCode();
                }
                if (this.Actions != null)
                {
                    hashCode = (hashCode * 59) + this.Actions.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Hidden.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
