/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the manipulation of a fixed value associated with a resource.
    /// </summary>
    [DataContract(Name = "FixedValueForResourceManipulationDto")]
    public partial class FixedValueForResourceManipulationDto : IEquatable<FixedValueForResourceManipulationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="FixedValueForResourceManipulationDto" /> class.
        /// </summary>
        /// <param name="value">Gets or initializes the value of the fixed resource value..</param>
        /// <param name="type">Gets or initializes the type of the fixed resource value..</param>
        /// <param name="datatype">Gets or initializes the data type URI of the fixed resource value..</param>
        /// <param name="targetClass">The target class of the provided value (e.g., \&quot;https://purl.org/coscine/ap/base/\&quot;).</param>
        public FixedValueForResourceManipulationDto(string value = default(string), string type = default(string), string datatype = default(string), string targetClass = default(string))
        {
            this.Value = value;
            this.Type = type;
            this.Datatype = datatype;
            this.TargetClass = targetClass;
        }

        /// <summary>
        /// Gets or initializes the value of the fixed resource value.
        /// </summary>
        /// <value>Gets or initializes the value of the fixed resource value.</value>
        [DataMember(Name = "value", EmitDefaultValue = true)]
        public string Value { get; set; }

        /// <summary>
        /// Gets or initializes the type of the fixed resource value.
        /// </summary>
        /// <value>Gets or initializes the type of the fixed resource value.</value>
        [DataMember(Name = "type", EmitDefaultValue = true)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or initializes the data type URI of the fixed resource value.
        /// </summary>
        /// <value>Gets or initializes the data type URI of the fixed resource value.</value>
        [DataMember(Name = "datatype", EmitDefaultValue = true)]
        public string Datatype { get; set; }

        /// <summary>
        /// The target class of the provided value (e.g., \&quot;https://purl.org/coscine/ap/base/\&quot;)
        /// </summary>
        /// <value>The target class of the provided value (e.g., \&quot;https://purl.org/coscine/ap/base/\&quot;)</value>
        [DataMember(Name = "targetClass", EmitDefaultValue = true)]
        public string TargetClass { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class FixedValueForResourceManipulationDto {\n");
            sb.Append("  Value: ").Append(Value).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  Datatype: ").Append(Datatype).Append("\n");
            sb.Append("  TargetClass: ").Append(TargetClass).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as FixedValueForResourceManipulationDto);
        }

        /// <summary>
        /// Returns true if FixedValueForResourceManipulationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of FixedValueForResourceManipulationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(FixedValueForResourceManipulationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Value == input.Value ||
                    (this.Value != null &&
                    this.Value.Equals(input.Value))
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.Datatype == input.Datatype ||
                    (this.Datatype != null &&
                    this.Datatype.Equals(input.Datatype))
                ) && 
                (
                    this.TargetClass == input.TargetClass ||
                    (this.TargetClass != null &&
                    this.TargetClass.Equals(input.TargetClass))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Value != null)
                {
                    hashCode = (hashCode * 59) + this.Value.GetHashCode();
                }
                if (this.Type != null)
                {
                    hashCode = (hashCode * 59) + this.Type.GetHashCode();
                }
                if (this.Datatype != null)
                {
                    hashCode = (hashCode * 59) + this.Datatype.GetHashCode();
                }
                if (this.TargetClass != null)
                {
                    hashCode = (hashCode * 59) + this.TargetClass.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
