/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for updating GitLab resource type options.
    /// </summary>
    [DataContract(Name = "GitlabResourceTypeOptionsForUpdateDto")]
    public partial class GitlabResourceTypeOptionsForUpdateDto : IEquatable<GitlabResourceTypeOptionsForUpdateDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="GitlabResourceTypeOptionsForUpdateDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected GitlabResourceTypeOptionsForUpdateDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="GitlabResourceTypeOptionsForUpdateDto" /> class.
        /// </summary>
        /// <param name="branch">The branch associated with the GitLab resource. (required).</param>
        /// <param name="accessToken">The access token for authentication with GitLab. (required).</param>
        public GitlabResourceTypeOptionsForUpdateDto(string branch = default(string), string accessToken = default(string))
        {
            // to ensure "branch" is required (not null)
            if (branch == null)
            {
                throw new ArgumentNullException("branch is a required property for GitlabResourceTypeOptionsForUpdateDto and cannot be null");
            }
            this.Branch = branch;
            // to ensure "accessToken" is required (not null)
            if (accessToken == null)
            {
                throw new ArgumentNullException("accessToken is a required property for GitlabResourceTypeOptionsForUpdateDto and cannot be null");
            }
            this.AccessToken = accessToken;
        }

        /// <summary>
        /// The branch associated with the GitLab resource.
        /// </summary>
        /// <value>The branch associated with the GitLab resource.</value>
        [DataMember(Name = "branch", IsRequired = true, EmitDefaultValue = true)]
        public string Branch { get; set; }

        /// <summary>
        /// The access token for authentication with GitLab.
        /// </summary>
        /// <value>The access token for authentication with GitLab.</value>
        [DataMember(Name = "accessToken", IsRequired = true, EmitDefaultValue = true)]
        public string AccessToken { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class GitlabResourceTypeOptionsForUpdateDto {\n");
            sb.Append("  Branch: ").Append(Branch).Append("\n");
            sb.Append("  AccessToken: ").Append(AccessToken).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as GitlabResourceTypeOptionsForUpdateDto);
        }

        /// <summary>
        /// Returns true if GitlabResourceTypeOptionsForUpdateDto instances are equal
        /// </summary>
        /// <param name="input">Instance of GitlabResourceTypeOptionsForUpdateDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(GitlabResourceTypeOptionsForUpdateDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Branch == input.Branch ||
                    (this.Branch != null &&
                    this.Branch.Equals(input.Branch))
                ) && 
                (
                    this.AccessToken == input.AccessToken ||
                    (this.AccessToken != null &&
                    this.AccessToken.Equals(input.AccessToken))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Branch != null)
                {
                    hashCode = (hashCode * 59) + this.Branch.GetHashCode();
                }
                if (this.AccessToken != null)
                {
                    hashCode = (hashCode * 59) + this.AccessToken.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Branch (string) minLength
            if (this.Branch != null && this.Branch.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Branch, length must be greater than 1.", new [] { "Branch" });
            }

            // AccessToken (string) minLength
            if (this.AccessToken != null && this.AccessToken.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for AccessToken, length must be greater than 1.", new [] { "AccessToken" });
            }

            yield break;
        }
    }

}
