/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// HandleValueDto
    /// </summary>
    [DataContract(Name = "HandleValueDto")]
    public partial class HandleValueDto : IEquatable<HandleValueDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HandleValueDto" /> class.
        /// </summary>
        /// <param name="idx">idx.</param>
        /// <param name="type">type.</param>
        /// <param name="parsedData">parsedData.</param>
        /// <param name="data">data.</param>
        /// <param name="timestamp">timestamp.</param>
        /// <param name="ttlType">ttlType.</param>
        /// <param name="ttl">ttl.</param>
        /// <param name="refs">refs.</param>
        /// <param name="privs">privs.</param>
        public HandleValueDto(int idx = default(int), string type = default(string), Object parsedData = default(Object), string data = default(string), DateTime timestamp = default(DateTime), int ttlType = default(int), int ttl = default(int), List<Object> refs = default(List<Object>), string privs = default(string))
        {
            this.Idx = idx;
            this.Type = type;
            this.ParsedData = parsedData;
            this.Data = data;
            this.Timestamp = timestamp;
            this.TtlType = ttlType;
            this.Ttl = ttl;
            this.Refs = refs;
            this.Privs = privs;
        }

        /// <summary>
        /// Gets or Sets Idx
        /// </summary>
        [DataMember(Name = "idx", EmitDefaultValue = false)]
        public int Idx { get; set; }

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public string Type { get; set; }

        /// <summary>
        /// Gets or Sets ParsedData
        /// </summary>
        [DataMember(Name = "parsed_data", EmitDefaultValue = true)]
        public Object ParsedData { get; set; }

        /// <summary>
        /// Gets or Sets Data
        /// </summary>
        [DataMember(Name = "data", EmitDefaultValue = false)]
        public string Data { get; set; }

        /// <summary>
        /// Gets or Sets Timestamp
        /// </summary>
        [DataMember(Name = "timestamp", EmitDefaultValue = false)]
        public DateTime Timestamp { get; set; }

        /// <summary>
        /// Gets or Sets TtlType
        /// </summary>
        [DataMember(Name = "ttl_type", EmitDefaultValue = false)]
        public int TtlType { get; set; }

        /// <summary>
        /// Gets or Sets Ttl
        /// </summary>
        [DataMember(Name = "ttl", EmitDefaultValue = false)]
        public int Ttl { get; set; }

        /// <summary>
        /// Gets or Sets Refs
        /// </summary>
        [DataMember(Name = "refs", EmitDefaultValue = false)]
        public List<Object> Refs { get; set; }

        /// <summary>
        /// Gets or Sets Privs
        /// </summary>
        [DataMember(Name = "privs", EmitDefaultValue = false)]
        public string Privs { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class HandleValueDto {\n");
            sb.Append("  Idx: ").Append(Idx).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ParsedData: ").Append(ParsedData).Append("\n");
            sb.Append("  Data: ").Append(Data).Append("\n");
            sb.Append("  Timestamp: ").Append(Timestamp).Append("\n");
            sb.Append("  TtlType: ").Append(TtlType).Append("\n");
            sb.Append("  Ttl: ").Append(Ttl).Append("\n");
            sb.Append("  Refs: ").Append(Refs).Append("\n");
            sb.Append("  Privs: ").Append(Privs).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HandleValueDto);
        }

        /// <summary>
        /// Returns true if HandleValueDto instances are equal
        /// </summary>
        /// <param name="input">Instance of HandleValueDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HandleValueDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Idx == input.Idx ||
                    this.Idx.Equals(input.Idx)
                ) && 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ParsedData == input.ParsedData ||
                    (this.ParsedData != null &&
                    this.ParsedData.Equals(input.ParsedData))
                ) && 
                (
                    this.Data == input.Data ||
                    (this.Data != null &&
                    this.Data.Equals(input.Data))
                ) && 
                (
                    this.Timestamp == input.Timestamp ||
                    (this.Timestamp != null &&
                    this.Timestamp.Equals(input.Timestamp))
                ) && 
                (
                    this.TtlType == input.TtlType ||
                    this.TtlType.Equals(input.TtlType)
                ) && 
                (
                    this.Ttl == input.Ttl ||
                    this.Ttl.Equals(input.Ttl)
                ) && 
                (
                    this.Refs == input.Refs ||
                    this.Refs != null &&
                    input.Refs != null &&
                    this.Refs.SequenceEqual(input.Refs)
                ) && 
                (
                    this.Privs == input.Privs ||
                    (this.Privs != null &&
                    this.Privs.Equals(input.Privs))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                hashCode = (hashCode * 59) + this.Idx.GetHashCode();
                if (this.Type != null)
                {
                    hashCode = (hashCode * 59) + this.Type.GetHashCode();
                }
                if (this.ParsedData != null)
                {
                    hashCode = (hashCode * 59) + this.ParsedData.GetHashCode();
                }
                if (this.Data != null)
                {
                    hashCode = (hashCode * 59) + this.Data.GetHashCode();
                }
                if (this.Timestamp != null)
                {
                    hashCode = (hashCode * 59) + this.Timestamp.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.TtlType.GetHashCode();
                hashCode = (hashCode * 59) + this.Ttl.GetHashCode();
                if (this.Refs != null)
                {
                    hashCode = (hashCode * 59) + this.Refs.GetHashCode();
                }
                if (this.Privs != null)
                {
                    hashCode = (hashCode * 59) + this.Privs.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
