/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing updating a handle.
    /// </summary>
    [DataContract(Name = "HandleValueForUpdateDto")]
    public partial class HandleValueForUpdateDto : IEquatable<HandleValueForUpdateDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HandleValueForUpdateDto" /> class.
        /// </summary>
        /// <param name="type">The data type of the handle..</param>
        /// <param name="parsedData">The parsed data of the handle..</param>
        /// <param name="idx">The id of the handle..</param>
        public HandleValueForUpdateDto(string type = default(string), Object parsedData = default(Object), int idx = default(int))
        {
            this.Type = type;
            this.ParsedData = parsedData;
            this.Idx = idx;
        }

        /// <summary>
        /// The data type of the handle.
        /// </summary>
        /// <value>The data type of the handle.</value>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public string Type { get; set; }

        /// <summary>
        /// The parsed data of the handle.
        /// </summary>
        /// <value>The parsed data of the handle.</value>
        [DataMember(Name = "parsed_data", EmitDefaultValue = true)]
        public Object ParsedData { get; set; }

        /// <summary>
        /// The id of the handle.
        /// </summary>
        /// <value>The id of the handle.</value>
        [DataMember(Name = "idx", EmitDefaultValue = false)]
        public int Idx { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class HandleValueForUpdateDto {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ParsedData: ").Append(ParsedData).Append("\n");
            sb.Append("  Idx: ").Append(Idx).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as HandleValueForUpdateDto);
        }

        /// <summary>
        /// Returns true if HandleValueForUpdateDto instances are equal
        /// </summary>
        /// <param name="input">Instance of HandleValueForUpdateDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(HandleValueForUpdateDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Type == input.Type ||
                    (this.Type != null &&
                    this.Type.Equals(input.Type))
                ) && 
                (
                    this.ParsedData == input.ParsedData ||
                    (this.ParsedData != null &&
                    this.ParsedData.Equals(input.ParsedData))
                ) && 
                (
                    this.Idx == input.Idx ||
                    this.Idx.Equals(input.Idx)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Type != null)
                {
                    hashCode = (hashCode * 59) + this.Type.GetHashCode();
                }
                if (this.ParsedData != null)
                {
                    hashCode = (hashCode * 59) + this.ParsedData.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Idx.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
