/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing an invitation for project manipulation.
    /// </summary>
    [DataContract(Name = "ProjectInvitationForProjectManipulationDto")]
    public partial class ProjectInvitationForProjectManipulationDto : IEquatable<ProjectInvitationForProjectManipulationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectInvitationForProjectManipulationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectInvitationForProjectManipulationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectInvitationForProjectManipulationDto" /> class.
        /// </summary>
        /// <param name="roleId">Gets or initializes the identifier of the role associated with the invitation. (required).</param>
        /// <param name="email">Gets or initializes the email address of the invited user. (required).</param>
        public ProjectInvitationForProjectManipulationDto(Guid roleId = default(Guid), string email = default(string))
        {
            this.RoleId = roleId;
            // to ensure "email" is required (not null)
            if (email == null)
            {
                throw new ArgumentNullException("email is a required property for ProjectInvitationForProjectManipulationDto and cannot be null");
            }
            this.Email = email;
        }

        /// <summary>
        /// Gets or initializes the identifier of the role associated with the invitation.
        /// </summary>
        /// <value>Gets or initializes the identifier of the role associated with the invitation.</value>
        [DataMember(Name = "roleId", IsRequired = true, EmitDefaultValue = true)]
        public Guid RoleId { get; set; }

        /// <summary>
        /// Gets or initializes the email address of the invited user.
        /// </summary>
        /// <value>Gets or initializes the email address of the invited user.</value>
        [DataMember(Name = "email", IsRequired = true, EmitDefaultValue = true)]
        public string Email { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectInvitationForProjectManipulationDto {\n");
            sb.Append("  RoleId: ").Append(RoleId).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectInvitationForProjectManipulationDto);
        }

        /// <summary>
        /// Returns true if ProjectInvitationForProjectManipulationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectInvitationForProjectManipulationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectInvitationForProjectManipulationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.RoleId == input.RoleId ||
                    (this.RoleId != null &&
                    this.RoleId.Equals(input.RoleId))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RoleId != null)
                {
                    hashCode = (hashCode * 59) + this.RoleId.GetHashCode();
                }
                if (this.Email != null)
                {
                    hashCode = (hashCode * 59) + this.Email.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Email (string) minLength
            if (this.Email != null && this.Email.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for Email, length must be greater than 1.", new [] { "Email" });
            }

            yield break;
        }
    }

}
