/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the update of project quotas.
    /// </summary>
    [DataContract(Name = "ProjectQuotaForUpdateDto")]
    public partial class ProjectQuotaForUpdateDto : IEquatable<ProjectQuotaForUpdateDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectQuotaForUpdateDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectQuotaForUpdateDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectQuotaForUpdateDto" /> class.
        /// </summary>
        /// <param name="allocated">allocated (required).</param>
        /// <param name="maximum">maximum.</param>
        public ProjectQuotaForUpdateDto(QuotaForManipulationDto allocated = default(QuotaForManipulationDto), QuotaForManipulationDto maximum = default(QuotaForManipulationDto))
        {
            // to ensure "allocated" is required (not null)
            if (allocated == null)
            {
                throw new ArgumentNullException("allocated is a required property for ProjectQuotaForUpdateDto and cannot be null");
            }
            this.Allocated = allocated;
            this.Maximum = maximum;
        }

        /// <summary>
        /// Gets or Sets Allocated
        /// </summary>
        [DataMember(Name = "allocated", IsRequired = true, EmitDefaultValue = true)]
        public QuotaForManipulationDto Allocated { get; set; }

        /// <summary>
        /// Gets or Sets Maximum
        /// </summary>
        [DataMember(Name = "maximum", EmitDefaultValue = false)]
        public QuotaForManipulationDto Maximum { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectQuotaForUpdateDto {\n");
            sb.Append("  Allocated: ").Append(Allocated).Append("\n");
            sb.Append("  Maximum: ").Append(Maximum).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectQuotaForUpdateDto);
        }

        /// <summary>
        /// Returns true if ProjectQuotaForUpdateDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectQuotaForUpdateDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectQuotaForUpdateDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Allocated == input.Allocated ||
                    (this.Allocated != null &&
                    this.Allocated.Equals(input.Allocated))
                ) && 
                (
                    this.Maximum == input.Maximum ||
                    (this.Maximum != null &&
                    this.Maximum.Equals(input.Maximum))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Allocated != null)
                {
                    hashCode = (hashCode * 59) + this.Allocated.GetHashCode();
                }
                if (this.Maximum != null)
                {
                    hashCode = (hashCode * 59) + this.Maximum.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
