/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of a project role within a project.  Inherits from the base class Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.ProjectRoleForProjectManipulationDto.
    /// </summary>
    [DataContract(Name = "ProjectRoleForProjectCreationDto")]
    public partial class ProjectRoleForProjectCreationDto : IEquatable<ProjectRoleForProjectCreationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectRoleForProjectCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectRoleForProjectCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectRoleForProjectCreationDto" /> class.
        /// </summary>
        /// <param name="roleId">Gets or initializes the identifier of the role associated with the project manipulation. (required).</param>
        /// <param name="userId">Gets or initializes the identifier of the user associated with the project role creation. (required).</param>
        public ProjectRoleForProjectCreationDto(Guid roleId = default(Guid), Guid userId = default(Guid))
        {
            this.RoleId = roleId;
            this.UserId = userId;
        }

        /// <summary>
        /// Gets or initializes the identifier of the role associated with the project manipulation.
        /// </summary>
        /// <value>Gets or initializes the identifier of the role associated with the project manipulation.</value>
        [DataMember(Name = "roleId", IsRequired = true, EmitDefaultValue = true)]
        public Guid RoleId { get; set; }

        /// <summary>
        /// Gets or initializes the identifier of the user associated with the project role creation.
        /// </summary>
        /// <value>Gets or initializes the identifier of the user associated with the project role creation.</value>
        [DataMember(Name = "userId", IsRequired = true, EmitDefaultValue = true)]
        public Guid UserId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectRoleForProjectCreationDto {\n");
            sb.Append("  RoleId: ").Append(RoleId).Append("\n");
            sb.Append("  UserId: ").Append(UserId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectRoleForProjectCreationDto);
        }

        /// <summary>
        /// Returns true if ProjectRoleForProjectCreationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectRoleForProjectCreationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectRoleForProjectCreationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.RoleId == input.RoleId ||
                    (this.RoleId != null &&
                    this.RoleId.Equals(input.RoleId))
                ) && 
                (
                    this.UserId == input.UserId ||
                    (this.UserId != null &&
                    this.UserId.Equals(input.UserId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RoleId != null)
                {
                    hashCode = (hashCode * 59) + this.RoleId.GetHashCode();
                }
                if (this.UserId != null)
                {
                    hashCode = (hashCode * 59) + this.UserId.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
