/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing a project role for manipulation within a project.
    /// </summary>
    [DataContract(Name = "ProjectRoleForProjectManipulationDto")]
    public partial class ProjectRoleForProjectManipulationDto : IEquatable<ProjectRoleForProjectManipulationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectRoleForProjectManipulationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectRoleForProjectManipulationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectRoleForProjectManipulationDto" /> class.
        /// </summary>
        /// <param name="roleId">Gets or initializes the identifier of the role associated with the project manipulation. (required).</param>
        public ProjectRoleForProjectManipulationDto(Guid roleId = default(Guid))
        {
            this.RoleId = roleId;
        }

        /// <summary>
        /// Gets or initializes the identifier of the role associated with the project manipulation.
        /// </summary>
        /// <value>Gets or initializes the identifier of the role associated with the project manipulation.</value>
        [DataMember(Name = "roleId", IsRequired = true, EmitDefaultValue = true)]
        public Guid RoleId { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectRoleForProjectManipulationDto {\n");
            sb.Append("  RoleId: ").Append(RoleId).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ProjectRoleForProjectManipulationDto);
        }

        /// <summary>
        /// Returns true if ProjectRoleForProjectManipulationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ProjectRoleForProjectManipulationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ProjectRoleForProjectManipulationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.RoleId == input.RoleId ||
                    (this.RoleId != null &&
                    this.RoleId.Equals(input.RoleId))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RoleId != null)
                {
                    hashCode = (hashCode * 59) + this.RoleId.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
