/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the creation of a publication request.
    /// </summary>
    [DataContract(Name = "PublicationRequestForCreationDto")]
    public partial class PublicationRequestForCreationDto : IEquatable<PublicationRequestForCreationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationRequestForCreationDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PublicationRequestForCreationDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PublicationRequestForCreationDto" /> class.
        /// </summary>
        /// <param name="dataPublicationServiceRorId">The data publication service&#39;s ror id. (required).</param>
        /// <param name="resourceIds">The resource guids. (required).</param>
        /// <param name="message">A message of the requester..</param>
        public PublicationRequestForCreationDto(string dataPublicationServiceRorId = default(string), List<Guid> resourceIds = default(List<Guid>), string message = default(string))
        {
            // to ensure "dataPublicationServiceRorId" is required (not null)
            if (dataPublicationServiceRorId == null)
            {
                throw new ArgumentNullException("dataPublicationServiceRorId is a required property for PublicationRequestForCreationDto and cannot be null");
            }
            this.DataPublicationServiceRorId = dataPublicationServiceRorId;
            // to ensure "resourceIds" is required (not null)
            if (resourceIds == null)
            {
                throw new ArgumentNullException("resourceIds is a required property for PublicationRequestForCreationDto and cannot be null");
            }
            this.ResourceIds = resourceIds;
            this.Message = message;
        }

        /// <summary>
        /// The data publication service&#39;s ror id.
        /// </summary>
        /// <value>The data publication service&#39;s ror id.</value>
        [DataMember(Name = "dataPublicationServiceRorId", IsRequired = true, EmitDefaultValue = true)]
        public string DataPublicationServiceRorId { get; set; }

        /// <summary>
        /// The resource guids.
        /// </summary>
        /// <value>The resource guids.</value>
        [DataMember(Name = "resourceIds", IsRequired = true, EmitDefaultValue = true)]
        public List<Guid> ResourceIds { get; set; }

        /// <summary>
        /// A message of the requester.
        /// </summary>
        /// <value>A message of the requester.</value>
        [DataMember(Name = "message", EmitDefaultValue = true)]
        public string Message { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class PublicationRequestForCreationDto {\n");
            sb.Append("  DataPublicationServiceRorId: ").Append(DataPublicationServiceRorId).Append("\n");
            sb.Append("  ResourceIds: ").Append(ResourceIds).Append("\n");
            sb.Append("  Message: ").Append(Message).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as PublicationRequestForCreationDto);
        }

        /// <summary>
        /// Returns true if PublicationRequestForCreationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of PublicationRequestForCreationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(PublicationRequestForCreationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.DataPublicationServiceRorId == input.DataPublicationServiceRorId ||
                    (this.DataPublicationServiceRorId != null &&
                    this.DataPublicationServiceRorId.Equals(input.DataPublicationServiceRorId))
                ) && 
                (
                    this.ResourceIds == input.ResourceIds ||
                    this.ResourceIds != null &&
                    input.ResourceIds != null &&
                    this.ResourceIds.SequenceEqual(input.ResourceIds)
                ) && 
                (
                    this.Message == input.Message ||
                    (this.Message != null &&
                    this.Message.Equals(input.Message))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.DataPublicationServiceRorId != null)
                {
                    hashCode = (hashCode * 59) + this.DataPublicationServiceRorId.GetHashCode();
                }
                if (this.ResourceIds != null)
                {
                    hashCode = (hashCode * 59) + this.ResourceIds.GetHashCode();
                }
                if (this.Message != null)
                {
                    hashCode = (hashCode * 59) + this.Message.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // DataPublicationServiceRorId (string) minLength
            if (this.DataPublicationServiceRorId != null && this.DataPublicationServiceRorId.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for DataPublicationServiceRorId, length must be greater than 1.", new [] { "DataPublicationServiceRorId" });
            }

            yield break;
        }
    }

}
