/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents an RDF Patch document containing a series of operations.
    /// </summary>
    [DataContract(Name = "RdfPatchDocumentDto")]
    public partial class RdfPatchDocumentDto : IEquatable<RdfPatchDocumentDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RdfPatchDocumentDto" /> class.
        /// </summary>
        /// <param name="operations">The list of operations in the RDF Patch document..</param>
        public RdfPatchDocumentDto(List<RdfPatchOperationDto> operations = default(List<RdfPatchOperationDto>))
        {
            this.Operations = operations;
        }

        /// <summary>
        /// The list of operations in the RDF Patch document.
        /// </summary>
        /// <value>The list of operations in the RDF Patch document.</value>
        [DataMember(Name = "operations", EmitDefaultValue = false)]
        public List<RdfPatchOperationDto> Operations { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdfPatchDocumentDto {\n");
            sb.Append("  Operations: ").Append(Operations).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as RdfPatchDocumentDto);
        }

        /// <summary>
        /// Returns true if RdfPatchDocumentDto instances are equal
        /// </summary>
        /// <param name="input">Instance of RdfPatchDocumentDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(RdfPatchDocumentDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Operations == input.Operations ||
                    this.Operations != null &&
                    input.Operations != null &&
                    this.Operations.SequenceEqual(input.Operations)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Operations != null)
                {
                    hashCode = (hashCode * 59) + this.Operations.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
