/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for RDS S3 options.
    /// </summary>
    [DataContract(Name = "RdsS3OptionsDto")]
    public partial class RdsS3OptionsDto : IEquatable<RdsS3OptionsDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsS3OptionsDto" /> class.
        /// </summary>
        /// <param name="bucketName">The name of the bucket associated with RDS S3..</param>
        /// <param name="accessKeyRead">The access key for reading from the RDS S3 bucket..</param>
        /// <param name="secretKeyRead">The secret key for reading from the RDS S3 bucket..</param>
        /// <param name="accessKeyWrite">The access key for writing to the RDS S3 bucket..</param>
        /// <param name="secretKeyWrite">The secret key for writing to the RDS S3 bucket..</param>
        /// <param name="endpoint">The endpoint for the RDS S3 bucket..</param>
        /// <param name="size">size.</param>
        public RdsS3OptionsDto(string bucketName = default(string), string accessKeyRead = default(string), string secretKeyRead = default(string), string accessKeyWrite = default(string), string secretKeyWrite = default(string), string endpoint = default(string), QuotaDto size = default(QuotaDto))
        {
            this.BucketName = bucketName;
            this.AccessKeyRead = accessKeyRead;
            this.SecretKeyRead = secretKeyRead;
            this.AccessKeyWrite = accessKeyWrite;
            this.SecretKeyWrite = secretKeyWrite;
            this.Endpoint = endpoint;
            this.Size = size;
        }

        /// <summary>
        /// The name of the bucket associated with RDS S3.
        /// </summary>
        /// <value>The name of the bucket associated with RDS S3.</value>
        [DataMember(Name = "bucketName", EmitDefaultValue = false)]
        public string BucketName { get; set; }

        /// <summary>
        /// The access key for reading from the RDS S3 bucket.
        /// </summary>
        /// <value>The access key for reading from the RDS S3 bucket.</value>
        [DataMember(Name = "accessKeyRead", EmitDefaultValue = false)]
        public string AccessKeyRead { get; set; }

        /// <summary>
        /// The secret key for reading from the RDS S3 bucket.
        /// </summary>
        /// <value>The secret key for reading from the RDS S3 bucket.</value>
        [DataMember(Name = "secretKeyRead", EmitDefaultValue = false)]
        public string SecretKeyRead { get; set; }

        /// <summary>
        /// The access key for writing to the RDS S3 bucket.
        /// </summary>
        /// <value>The access key for writing to the RDS S3 bucket.</value>
        [DataMember(Name = "accessKeyWrite", EmitDefaultValue = false)]
        public string AccessKeyWrite { get; set; }

        /// <summary>
        /// The secret key for writing to the RDS S3 bucket.
        /// </summary>
        /// <value>The secret key for writing to the RDS S3 bucket.</value>
        [DataMember(Name = "secretKeyWrite", EmitDefaultValue = false)]
        public string SecretKeyWrite { get; set; }

        /// <summary>
        /// The endpoint for the RDS S3 bucket.
        /// </summary>
        /// <value>The endpoint for the RDS S3 bucket.</value>
        [DataMember(Name = "endpoint", EmitDefaultValue = false)]
        public string Endpoint { get; set; }

        /// <summary>
        /// Gets or Sets Size
        /// </summary>
        [DataMember(Name = "size", EmitDefaultValue = false)]
        public QuotaDto Size { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdsS3OptionsDto {\n");
            sb.Append("  BucketName: ").Append(BucketName).Append("\n");
            sb.Append("  AccessKeyRead: ").Append(AccessKeyRead).Append("\n");
            sb.Append("  SecretKeyRead: ").Append(SecretKeyRead).Append("\n");
            sb.Append("  AccessKeyWrite: ").Append(AccessKeyWrite).Append("\n");
            sb.Append("  SecretKeyWrite: ").Append(SecretKeyWrite).Append("\n");
            sb.Append("  Endpoint: ").Append(Endpoint).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as RdsS3OptionsDto);
        }

        /// <summary>
        /// Returns true if RdsS3OptionsDto instances are equal
        /// </summary>
        /// <param name="input">Instance of RdsS3OptionsDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(RdsS3OptionsDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.BucketName == input.BucketName ||
                    (this.BucketName != null &&
                    this.BucketName.Equals(input.BucketName))
                ) && 
                (
                    this.AccessKeyRead == input.AccessKeyRead ||
                    (this.AccessKeyRead != null &&
                    this.AccessKeyRead.Equals(input.AccessKeyRead))
                ) && 
                (
                    this.SecretKeyRead == input.SecretKeyRead ||
                    (this.SecretKeyRead != null &&
                    this.SecretKeyRead.Equals(input.SecretKeyRead))
                ) && 
                (
                    this.AccessKeyWrite == input.AccessKeyWrite ||
                    (this.AccessKeyWrite != null &&
                    this.AccessKeyWrite.Equals(input.AccessKeyWrite))
                ) && 
                (
                    this.SecretKeyWrite == input.SecretKeyWrite ||
                    (this.SecretKeyWrite != null &&
                    this.SecretKeyWrite.Equals(input.SecretKeyWrite))
                ) && 
                (
                    this.Endpoint == input.Endpoint ||
                    (this.Endpoint != null &&
                    this.Endpoint.Equals(input.Endpoint))
                ) && 
                (
                    this.Size == input.Size ||
                    (this.Size != null &&
                    this.Size.Equals(input.Size))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BucketName != null)
                {
                    hashCode = (hashCode * 59) + this.BucketName.GetHashCode();
                }
                if (this.AccessKeyRead != null)
                {
                    hashCode = (hashCode * 59) + this.AccessKeyRead.GetHashCode();
                }
                if (this.SecretKeyRead != null)
                {
                    hashCode = (hashCode * 59) + this.SecretKeyRead.GetHashCode();
                }
                if (this.AccessKeyWrite != null)
                {
                    hashCode = (hashCode * 59) + this.AccessKeyWrite.GetHashCode();
                }
                if (this.SecretKeyWrite != null)
                {
                    hashCode = (hashCode * 59) + this.SecretKeyWrite.GetHashCode();
                }
                if (this.Endpoint != null)
                {
                    hashCode = (hashCode * 59) + this.Endpoint.GetHashCode();
                }
                if (this.Size != null)
                {
                    hashCode = (hashCode * 59) + this.Size.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
