/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents information about a resource type.
    /// </summary>
    [DataContract(Name = "ResourceTypeInformationDto")]
    public partial class ResourceTypeInformationDto : IEquatable<ResourceTypeInformationDto>, IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Status
        /// </summary>
        [DataMember(Name = "status", EmitDefaultValue = false)]
        public ResourceTypeStatus? Status { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeInformationDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier of the resource type..</param>
        /// <param name="generalType">The general type of the resource..</param>
        /// <param name="specificType">The specific type of the resource..</param>
        /// <param name="status">status.</param>
        /// <param name="canCreate">Indicates if the resource type supports creation..</param>
        /// <param name="canRead">Indicates if the resource type supports reading..</param>
        /// <param name="canSetResourceReadonly">Indicates if the resource type supports read-only..</param>
        /// <param name="canUpdate">Indicates if the resource type supports updating..</param>
        /// <param name="canUpdateResource">Indicates if the resource type supports updating (not an Object)..</param>
        /// <param name="canDelete">Indicates if the resource type supports deletion..</param>
        /// <param name="canDeleteResource">Indicates if the resource type supports deletion (not an Object)..</param>
        /// <param name="canList">Indicates if the resource type supports listing..</param>
        /// <param name="canCreateLinks">Indicates if the resource type supports linking..</param>
        /// <param name="canCopyLocalMetadata">Indicates whether local backup of metadata is supported..</param>
        /// <param name="isArchived">Indicates if the resource type is archived..</param>
        /// <param name="isQuotaAvailable">Indicates if the resource type supports quota..</param>
        /// <param name="isQuotaAdjustable">Indicates if the resource type quota can be changed..</param>
        /// <param name="resourceCreation">resourceCreation.</param>
        /// <param name="resourceContent">resourceContent.</param>
        public ResourceTypeInformationDto(Guid id = default(Guid), string generalType = default(string), string specificType = default(string), ResourceTypeStatus? status = default(ResourceTypeStatus?), bool canCreate = default(bool), bool canRead = default(bool), bool canSetResourceReadonly = default(bool), bool canUpdate = default(bool), bool canUpdateResource = default(bool), bool canDelete = default(bool), bool canDeleteResource = default(bool), bool canList = default(bool), bool canCreateLinks = default(bool), bool canCopyLocalMetadata = default(bool), bool isArchived = default(bool), bool isQuotaAvailable = default(bool), bool isQuotaAdjustable = default(bool), ResourceCreationPageDto resourceCreation = default(ResourceCreationPageDto), ResourceContentPageDto resourceContent = default(ResourceContentPageDto))
        {
            this.Id = id;
            this.GeneralType = generalType;
            this.SpecificType = specificType;
            this.Status = status;
            this.CanCreate = canCreate;
            this.CanRead = canRead;
            this.CanSetResourceReadonly = canSetResourceReadonly;
            this.CanUpdate = canUpdate;
            this.CanUpdateResource = canUpdateResource;
            this.CanDelete = canDelete;
            this.CanDeleteResource = canDeleteResource;
            this.CanList = canList;
            this.CanCreateLinks = canCreateLinks;
            this.CanCopyLocalMetadata = canCopyLocalMetadata;
            this.IsArchived = isArchived;
            this.IsQuotaAvailable = isQuotaAvailable;
            this.IsQuotaAdjustable = isQuotaAdjustable;
            this.ResourceCreation = resourceCreation;
            this.ResourceContent = resourceContent;
        }

        /// <summary>
        /// The unique identifier of the resource type.
        /// </summary>
        /// <value>The unique identifier of the resource type.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// The general type of the resource.
        /// </summary>
        /// <value>The general type of the resource.</value>
        [DataMember(Name = "generalType", EmitDefaultValue = true)]
        public string GeneralType { get; set; }

        /// <summary>
        /// The specific type of the resource.
        /// </summary>
        /// <value>The specific type of the resource.</value>
        [DataMember(Name = "specificType", EmitDefaultValue = true)]
        public string SpecificType { get; set; }

        /// <summary>
        /// Indicates if the resource type supports creation.
        /// </summary>
        /// <value>Indicates if the resource type supports creation.</value>
        [DataMember(Name = "canCreate", EmitDefaultValue = true)]
        public bool CanCreate { get; set; }

        /// <summary>
        /// Indicates if the resource type supports reading.
        /// </summary>
        /// <value>Indicates if the resource type supports reading.</value>
        [DataMember(Name = "canRead", EmitDefaultValue = true)]
        public bool CanRead { get; set; }

        /// <summary>
        /// Indicates if the resource type supports read-only.
        /// </summary>
        /// <value>Indicates if the resource type supports read-only.</value>
        [DataMember(Name = "canSetResourceReadonly", EmitDefaultValue = true)]
        public bool CanSetResourceReadonly { get; set; }

        /// <summary>
        /// Indicates if the resource type supports updating.
        /// </summary>
        /// <value>Indicates if the resource type supports updating.</value>
        [DataMember(Name = "canUpdate", EmitDefaultValue = true)]
        public bool CanUpdate { get; set; }

        /// <summary>
        /// Indicates if the resource type supports updating (not an Object).
        /// </summary>
        /// <value>Indicates if the resource type supports updating (not an Object).</value>
        [DataMember(Name = "canUpdateResource", EmitDefaultValue = true)]
        public bool CanUpdateResource { get; set; }

        /// <summary>
        /// Indicates if the resource type supports deletion.
        /// </summary>
        /// <value>Indicates if the resource type supports deletion.</value>
        [DataMember(Name = "canDelete", EmitDefaultValue = true)]
        public bool CanDelete { get; set; }

        /// <summary>
        /// Indicates if the resource type supports deletion (not an Object).
        /// </summary>
        /// <value>Indicates if the resource type supports deletion (not an Object).</value>
        [DataMember(Name = "canDeleteResource", EmitDefaultValue = true)]
        public bool CanDeleteResource { get; set; }

        /// <summary>
        /// Indicates if the resource type supports listing.
        /// </summary>
        /// <value>Indicates if the resource type supports listing.</value>
        [DataMember(Name = "canList", EmitDefaultValue = true)]
        public bool CanList { get; set; }

        /// <summary>
        /// Indicates if the resource type supports linking.
        /// </summary>
        /// <value>Indicates if the resource type supports linking.</value>
        [DataMember(Name = "canCreateLinks", EmitDefaultValue = true)]
        public bool CanCreateLinks { get; set; }

        /// <summary>
        /// Indicates whether local backup of metadata is supported.
        /// </summary>
        /// <value>Indicates whether local backup of metadata is supported.</value>
        [DataMember(Name = "canCopyLocalMetadata", EmitDefaultValue = true)]
        public bool CanCopyLocalMetadata { get; set; }

        /// <summary>
        /// Indicates if the resource type is archived.
        /// </summary>
        /// <value>Indicates if the resource type is archived.</value>
        [DataMember(Name = "isArchived", EmitDefaultValue = true)]
        public bool IsArchived { get; set; }

        /// <summary>
        /// Indicates if the resource type supports quota.
        /// </summary>
        /// <value>Indicates if the resource type supports quota.</value>
        [DataMember(Name = "isQuotaAvailable", EmitDefaultValue = true)]
        public bool IsQuotaAvailable { get; set; }

        /// <summary>
        /// Indicates if the resource type quota can be changed.
        /// </summary>
        /// <value>Indicates if the resource type quota can be changed.</value>
        [DataMember(Name = "isQuotaAdjustable", EmitDefaultValue = true)]
        public bool IsQuotaAdjustable { get; set; }

        /// <summary>
        /// Indicates if the resource type is enabled.
        /// </summary>
        /// <value>Indicates if the resource type is enabled.</value>
        [DataMember(Name = "isEnabled", EmitDefaultValue = true)]
        public bool IsEnabled { get; private set; }

        /// <summary>
        /// Returns false as IsEnabled should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeIsEnabled()
        {
            return false;
        }
        /// <summary>
        /// Gets or Sets ResourceCreation
        /// </summary>
        [DataMember(Name = "resourceCreation", EmitDefaultValue = false)]
        public ResourceCreationPageDto ResourceCreation { get; set; }

        /// <summary>
        /// Gets or Sets ResourceContent
        /// </summary>
        [DataMember(Name = "resourceContent", EmitDefaultValue = false)]
        public ResourceContentPageDto ResourceContent { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceTypeInformationDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  GeneralType: ").Append(GeneralType).Append("\n");
            sb.Append("  SpecificType: ").Append(SpecificType).Append("\n");
            sb.Append("  Status: ").Append(Status).Append("\n");
            sb.Append("  CanCreate: ").Append(CanCreate).Append("\n");
            sb.Append("  CanRead: ").Append(CanRead).Append("\n");
            sb.Append("  CanSetResourceReadonly: ").Append(CanSetResourceReadonly).Append("\n");
            sb.Append("  CanUpdate: ").Append(CanUpdate).Append("\n");
            sb.Append("  CanUpdateResource: ").Append(CanUpdateResource).Append("\n");
            sb.Append("  CanDelete: ").Append(CanDelete).Append("\n");
            sb.Append("  CanDeleteResource: ").Append(CanDeleteResource).Append("\n");
            sb.Append("  CanList: ").Append(CanList).Append("\n");
            sb.Append("  CanCreateLinks: ").Append(CanCreateLinks).Append("\n");
            sb.Append("  CanCopyLocalMetadata: ").Append(CanCopyLocalMetadata).Append("\n");
            sb.Append("  IsArchived: ").Append(IsArchived).Append("\n");
            sb.Append("  IsQuotaAvailable: ").Append(IsQuotaAvailable).Append("\n");
            sb.Append("  IsQuotaAdjustable: ").Append(IsQuotaAdjustable).Append("\n");
            sb.Append("  IsEnabled: ").Append(IsEnabled).Append("\n");
            sb.Append("  ResourceCreation: ").Append(ResourceCreation).Append("\n");
            sb.Append("  ResourceContent: ").Append(ResourceContent).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ResourceTypeInformationDto);
        }

        /// <summary>
        /// Returns true if ResourceTypeInformationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ResourceTypeInformationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ResourceTypeInformationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.GeneralType == input.GeneralType ||
                    (this.GeneralType != null &&
                    this.GeneralType.Equals(input.GeneralType))
                ) && 
                (
                    this.SpecificType == input.SpecificType ||
                    (this.SpecificType != null &&
                    this.SpecificType.Equals(input.SpecificType))
                ) && 
                (
                    this.Status == input.Status ||
                    this.Status.Equals(input.Status)
                ) && 
                (
                    this.CanCreate == input.CanCreate ||
                    this.CanCreate.Equals(input.CanCreate)
                ) && 
                (
                    this.CanRead == input.CanRead ||
                    this.CanRead.Equals(input.CanRead)
                ) && 
                (
                    this.CanSetResourceReadonly == input.CanSetResourceReadonly ||
                    this.CanSetResourceReadonly.Equals(input.CanSetResourceReadonly)
                ) && 
                (
                    this.CanUpdate == input.CanUpdate ||
                    this.CanUpdate.Equals(input.CanUpdate)
                ) && 
                (
                    this.CanUpdateResource == input.CanUpdateResource ||
                    this.CanUpdateResource.Equals(input.CanUpdateResource)
                ) && 
                (
                    this.CanDelete == input.CanDelete ||
                    this.CanDelete.Equals(input.CanDelete)
                ) && 
                (
                    this.CanDeleteResource == input.CanDeleteResource ||
                    this.CanDeleteResource.Equals(input.CanDeleteResource)
                ) && 
                (
                    this.CanList == input.CanList ||
                    this.CanList.Equals(input.CanList)
                ) && 
                (
                    this.CanCreateLinks == input.CanCreateLinks ||
                    this.CanCreateLinks.Equals(input.CanCreateLinks)
                ) && 
                (
                    this.CanCopyLocalMetadata == input.CanCopyLocalMetadata ||
                    this.CanCopyLocalMetadata.Equals(input.CanCopyLocalMetadata)
                ) && 
                (
                    this.IsArchived == input.IsArchived ||
                    this.IsArchived.Equals(input.IsArchived)
                ) && 
                (
                    this.IsQuotaAvailable == input.IsQuotaAvailable ||
                    this.IsQuotaAvailable.Equals(input.IsQuotaAvailable)
                ) && 
                (
                    this.IsQuotaAdjustable == input.IsQuotaAdjustable ||
                    this.IsQuotaAdjustable.Equals(input.IsQuotaAdjustable)
                ) && 
                (
                    this.IsEnabled == input.IsEnabled ||
                    this.IsEnabled.Equals(input.IsEnabled)
                ) && 
                (
                    this.ResourceCreation == input.ResourceCreation ||
                    (this.ResourceCreation != null &&
                    this.ResourceCreation.Equals(input.ResourceCreation))
                ) && 
                (
                    this.ResourceContent == input.ResourceContent ||
                    (this.ResourceContent != null &&
                    this.ResourceContent.Equals(input.ResourceContent))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.GeneralType != null)
                {
                    hashCode = (hashCode * 59) + this.GeneralType.GetHashCode();
                }
                if (this.SpecificType != null)
                {
                    hashCode = (hashCode * 59) + this.SpecificType.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.Status.GetHashCode();
                hashCode = (hashCode * 59) + this.CanCreate.GetHashCode();
                hashCode = (hashCode * 59) + this.CanRead.GetHashCode();
                hashCode = (hashCode * 59) + this.CanSetResourceReadonly.GetHashCode();
                hashCode = (hashCode * 59) + this.CanUpdate.GetHashCode();
                hashCode = (hashCode * 59) + this.CanUpdateResource.GetHashCode();
                hashCode = (hashCode * 59) + this.CanDelete.GetHashCode();
                hashCode = (hashCode * 59) + this.CanDeleteResource.GetHashCode();
                hashCode = (hashCode * 59) + this.CanList.GetHashCode();
                hashCode = (hashCode * 59) + this.CanCreateLinks.GetHashCode();
                hashCode = (hashCode * 59) + this.CanCopyLocalMetadata.GetHashCode();
                hashCode = (hashCode * 59) + this.IsArchived.GetHashCode();
                hashCode = (hashCode * 59) + this.IsQuotaAvailable.GetHashCode();
                hashCode = (hashCode * 59) + this.IsQuotaAdjustable.GetHashCode();
                hashCode = (hashCode * 59) + this.IsEnabled.GetHashCode();
                if (this.ResourceCreation != null)
                {
                    hashCode = (hashCode * 59) + this.ResourceCreation.GetHashCode();
                }
                if (this.ResourceContent != null)
                {
                    hashCode = (hashCode * 59) + this.ResourceContent.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
