/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the options available for different resource types.
    /// </summary>
    [DataContract(Name = "ResourceTypeOptionsDto")]
    public partial class ResourceTypeOptionsDto : IEquatable<ResourceTypeOptionsDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeOptionsDto" /> class.
        /// </summary>
        /// <param name="linkedData">Represents the data transfer object (DTO) for Linked Data options..</param>
        /// <param name="gitLab">gitLab.</param>
        /// <param name="rds">rds.</param>
        /// <param name="rdsS3">rdsS3.</param>
        /// <param name="rdsS3Worm">rdsS3Worm.</param>
        public ResourceTypeOptionsDto(Object linkedData = default(Object), GitLabOptionsDto gitLab = default(GitLabOptionsDto), RdsOptionsDto rds = default(RdsOptionsDto), RdsS3OptionsDto rdsS3 = default(RdsS3OptionsDto), RdsS3WormOptionsDto rdsS3Worm = default(RdsS3WormOptionsDto))
        {
            this.LinkedData = linkedData;
            this.GitLab = gitLab;
            this.Rds = rds;
            this.RdsS3 = rdsS3;
            this.RdsS3Worm = rdsS3Worm;
        }

        /// <summary>
        /// Represents the data transfer object (DTO) for Linked Data options.
        /// </summary>
        /// <value>Represents the data transfer object (DTO) for Linked Data options.</value>
        [DataMember(Name = "linkedData", EmitDefaultValue = false)]
        public Object LinkedData { get; set; }

        /// <summary>
        /// Gets or Sets GitLab
        /// </summary>
        [DataMember(Name = "gitLab", EmitDefaultValue = false)]
        public GitLabOptionsDto GitLab { get; set; }

        /// <summary>
        /// Gets or Sets Rds
        /// </summary>
        [DataMember(Name = "rds", EmitDefaultValue = false)]
        public RdsOptionsDto Rds { get; set; }

        /// <summary>
        /// Gets or Sets RdsS3
        /// </summary>
        [DataMember(Name = "rdsS3", EmitDefaultValue = false)]
        public RdsS3OptionsDto RdsS3 { get; set; }

        /// <summary>
        /// Gets or Sets RdsS3Worm
        /// </summary>
        [DataMember(Name = "rdsS3Worm", EmitDefaultValue = false)]
        public RdsS3WormOptionsDto RdsS3Worm { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceTypeOptionsDto {\n");
            sb.Append("  LinkedData: ").Append(LinkedData).Append("\n");
            sb.Append("  GitLab: ").Append(GitLab).Append("\n");
            sb.Append("  Rds: ").Append(Rds).Append("\n");
            sb.Append("  RdsS3: ").Append(RdsS3).Append("\n");
            sb.Append("  RdsS3Worm: ").Append(RdsS3Worm).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ResourceTypeOptionsDto);
        }

        /// <summary>
        /// Returns true if ResourceTypeOptionsDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ResourceTypeOptionsDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ResourceTypeOptionsDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.LinkedData == input.LinkedData ||
                    (this.LinkedData != null &&
                    this.LinkedData.Equals(input.LinkedData))
                ) && 
                (
                    this.GitLab == input.GitLab ||
                    (this.GitLab != null &&
                    this.GitLab.Equals(input.GitLab))
                ) && 
                (
                    this.Rds == input.Rds ||
                    (this.Rds != null &&
                    this.Rds.Equals(input.Rds))
                ) && 
                (
                    this.RdsS3 == input.RdsS3 ||
                    (this.RdsS3 != null &&
                    this.RdsS3.Equals(input.RdsS3))
                ) && 
                (
                    this.RdsS3Worm == input.RdsS3Worm ||
                    (this.RdsS3Worm != null &&
                    this.RdsS3Worm.Equals(input.RdsS3Worm))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LinkedData != null)
                {
                    hashCode = (hashCode * 59) + this.LinkedData.GetHashCode();
                }
                if (this.GitLab != null)
                {
                    hashCode = (hashCode * 59) + this.GitLab.GetHashCode();
                }
                if (this.Rds != null)
                {
                    hashCode = (hashCode * 59) + this.Rds.GetHashCode();
                }
                if (this.RdsS3 != null)
                {
                    hashCode = (hashCode * 59) + this.RdsS3.GetHashCode();
                }
                if (this.RdsS3Worm != null)
                {
                    hashCode = (hashCode * 59) + this.RdsS3Worm.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
