/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) used for updating options related to any resource type.
    /// </summary>
    [DataContract(Name = "ResourceTypeOptionsForUpdateDto")]
    public partial class ResourceTypeOptionsForUpdateDto : IEquatable<ResourceTypeOptionsForUpdateDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ResourceTypeOptionsForUpdateDto" /> class.
        /// </summary>
        /// <param name="linkedResourceTypeOptions">Represents the data transfer object (DTO) for manipulating linked data resource type options..</param>
        /// <param name="gitlabResourceTypeOptions">gitlabResourceTypeOptions.</param>
        /// <param name="rdsResourceTypeOptions">rdsResourceTypeOptions.</param>
        /// <param name="rdsS3ResourceTypeOptions">rdsS3ResourceTypeOptions.</param>
        /// <param name="rdsS3WormResourceTypeOptions">rdsS3WormResourceTypeOptions.</param>
        public ResourceTypeOptionsForUpdateDto(Object linkedResourceTypeOptions = default(Object), GitlabResourceTypeOptionsForUpdateDto gitlabResourceTypeOptions = default(GitlabResourceTypeOptionsForUpdateDto), RdsResourceTypeOptionsForManipulationDto rdsResourceTypeOptions = default(RdsResourceTypeOptionsForManipulationDto), RdsS3ResourceTypeOptionsForManipulationDto rdsS3ResourceTypeOptions = default(RdsS3ResourceTypeOptionsForManipulationDto), RdsS3WormResourceTypeOptionsForManipulationDto rdsS3WormResourceTypeOptions = default(RdsS3WormResourceTypeOptionsForManipulationDto))
        {
            this.LinkedResourceTypeOptions = linkedResourceTypeOptions;
            this.GitlabResourceTypeOptions = gitlabResourceTypeOptions;
            this.RdsResourceTypeOptions = rdsResourceTypeOptions;
            this.RdsS3ResourceTypeOptions = rdsS3ResourceTypeOptions;
            this.RdsS3WormResourceTypeOptions = rdsS3WormResourceTypeOptions;
        }

        /// <summary>
        /// Represents the data transfer object (DTO) for manipulating linked data resource type options.
        /// </summary>
        /// <value>Represents the data transfer object (DTO) for manipulating linked data resource type options.</value>
        [DataMember(Name = "linkedResourceTypeOptions", EmitDefaultValue = false)]
        public Object LinkedResourceTypeOptions { get; set; }

        /// <summary>
        /// Gets or Sets GitlabResourceTypeOptions
        /// </summary>
        [DataMember(Name = "gitlabResourceTypeOptions", EmitDefaultValue = false)]
        public GitlabResourceTypeOptionsForUpdateDto GitlabResourceTypeOptions { get; set; }

        /// <summary>
        /// Gets or Sets RdsResourceTypeOptions
        /// </summary>
        [DataMember(Name = "rdsResourceTypeOptions", EmitDefaultValue = false)]
        public RdsResourceTypeOptionsForManipulationDto RdsResourceTypeOptions { get; set; }

        /// <summary>
        /// Gets or Sets RdsS3ResourceTypeOptions
        /// </summary>
        [DataMember(Name = "rdsS3ResourceTypeOptions", EmitDefaultValue = false)]
        public RdsS3ResourceTypeOptionsForManipulationDto RdsS3ResourceTypeOptions { get; set; }

        /// <summary>
        /// Gets or Sets RdsS3WormResourceTypeOptions
        /// </summary>
        [DataMember(Name = "rdsS3WormResourceTypeOptions", EmitDefaultValue = false)]
        public RdsS3WormResourceTypeOptionsForManipulationDto RdsS3WormResourceTypeOptions { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ResourceTypeOptionsForUpdateDto {\n");
            sb.Append("  LinkedResourceTypeOptions: ").Append(LinkedResourceTypeOptions).Append("\n");
            sb.Append("  GitlabResourceTypeOptions: ").Append(GitlabResourceTypeOptions).Append("\n");
            sb.Append("  RdsResourceTypeOptions: ").Append(RdsResourceTypeOptions).Append("\n");
            sb.Append("  RdsS3ResourceTypeOptions: ").Append(RdsS3ResourceTypeOptions).Append("\n");
            sb.Append("  RdsS3WormResourceTypeOptions: ").Append(RdsS3WormResourceTypeOptions).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ResourceTypeOptionsForUpdateDto);
        }

        /// <summary>
        /// Returns true if ResourceTypeOptionsForUpdateDto instances are equal
        /// </summary>
        /// <param name="input">Instance of ResourceTypeOptionsForUpdateDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ResourceTypeOptionsForUpdateDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.LinkedResourceTypeOptions == input.LinkedResourceTypeOptions ||
                    (this.LinkedResourceTypeOptions != null &&
                    this.LinkedResourceTypeOptions.Equals(input.LinkedResourceTypeOptions))
                ) && 
                (
                    this.GitlabResourceTypeOptions == input.GitlabResourceTypeOptions ||
                    (this.GitlabResourceTypeOptions != null &&
                    this.GitlabResourceTypeOptions.Equals(input.GitlabResourceTypeOptions))
                ) && 
                (
                    this.RdsResourceTypeOptions == input.RdsResourceTypeOptions ||
                    (this.RdsResourceTypeOptions != null &&
                    this.RdsResourceTypeOptions.Equals(input.RdsResourceTypeOptions))
                ) && 
                (
                    this.RdsS3ResourceTypeOptions == input.RdsS3ResourceTypeOptions ||
                    (this.RdsS3ResourceTypeOptions != null &&
                    this.RdsS3ResourceTypeOptions.Equals(input.RdsS3ResourceTypeOptions))
                ) && 
                (
                    this.RdsS3WormResourceTypeOptions == input.RdsS3WormResourceTypeOptions ||
                    (this.RdsS3WormResourceTypeOptions != null &&
                    this.RdsS3WormResourceTypeOptions.Equals(input.RdsS3WormResourceTypeOptions))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LinkedResourceTypeOptions != null)
                {
                    hashCode = (hashCode * 59) + this.LinkedResourceTypeOptions.GetHashCode();
                }
                if (this.GitlabResourceTypeOptions != null)
                {
                    hashCode = (hashCode * 59) + this.GitlabResourceTypeOptions.GetHashCode();
                }
                if (this.RdsResourceTypeOptions != null)
                {
                    hashCode = (hashCode * 59) + this.RdsResourceTypeOptions.GetHashCode();
                }
                if (this.RdsS3ResourceTypeOptions != null)
                {
                    hashCode = (hashCode * 59) + this.RdsS3ResourceTypeOptions.GetHashCode();
                }
                if (this.RdsS3WormResourceTypeOptions != null)
                {
                    hashCode = (hashCode * 59) + this.RdsS3WormResourceTypeOptions.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
