/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for user-related information.
    /// </summary>
    [DataContract(Name = "UserDto")]
    public partial class UserDto : IEquatable<UserDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserDto" /> class.
        /// </summary>
        /// <param name="id">The unique identifier of the user..</param>
        /// <param name="displayName">The display name of the user..</param>
        /// <param name="givenName">The given name of the user..</param>
        /// <param name="familyName">The family name of the user..</param>
        /// <param name="emails">The email addresses associated with the user..</param>
        /// <param name="title">title.</param>
        /// <param name="language">language.</param>
        /// <param name="areToSAccepted">Indicates if the terms of service are accepted by the user..</param>
        /// <param name="latestActivity">The date and time of the latest activity of the user..</param>
        /// <param name="disciplines">The disciplines associated with the user..</param>
        /// <param name="organizations">The organizations associated with the user..</param>
        /// <param name="institutes">The institutes associated with the user..</param>
        /// <param name="identities">The identity providers associated with the user..</param>
        public UserDto(Guid id = default(Guid), string displayName = default(string), string givenName = default(string), string familyName = default(string), List<UserEmailDto> emails = default(List<UserEmailDto>), TitleDto title = default(TitleDto), LanguageDto language = default(LanguageDto), bool areToSAccepted = default(bool), DateTime? latestActivity = default(DateTime?), List<DisciplineDto> disciplines = default(List<DisciplineDto>), List<UserOrganizationDto> organizations = default(List<UserOrganizationDto>), List<UserInstituteDto> institutes = default(List<UserInstituteDto>), List<IdentityProviderDto> identities = default(List<IdentityProviderDto>))
        {
            this.Id = id;
            this.DisplayName = displayName;
            this.GivenName = givenName;
            this.FamilyName = familyName;
            this.Emails = emails;
            this.Title = title;
            this.Language = language;
            this.AreToSAccepted = areToSAccepted;
            this.LatestActivity = latestActivity;
            this.Disciplines = disciplines;
            this.Organizations = organizations;
            this.Institutes = institutes;
            this.Identities = identities;
        }

        /// <summary>
        /// The unique identifier of the user.
        /// </summary>
        /// <value>The unique identifier of the user.</value>
        [DataMember(Name = "id", EmitDefaultValue = false)]
        public Guid Id { get; set; }

        /// <summary>
        /// The display name of the user.
        /// </summary>
        /// <value>The display name of the user.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = false)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The given name of the user.
        /// </summary>
        /// <value>The given name of the user.</value>
        [DataMember(Name = "givenName", EmitDefaultValue = false)]
        public string GivenName { get; set; }

        /// <summary>
        /// The family name of the user.
        /// </summary>
        /// <value>The family name of the user.</value>
        [DataMember(Name = "familyName", EmitDefaultValue = false)]
        public string FamilyName { get; set; }

        /// <summary>
        /// The email addresses associated with the user.
        /// </summary>
        /// <value>The email addresses associated with the user.</value>
        [DataMember(Name = "emails", EmitDefaultValue = false)]
        public List<UserEmailDto> Emails { get; set; }

        /// <summary>
        /// Gets or Sets Title
        /// </summary>
        [DataMember(Name = "title", EmitDefaultValue = false)]
        public TitleDto Title { get; set; }

        /// <summary>
        /// Gets or Sets Language
        /// </summary>
        [DataMember(Name = "language", EmitDefaultValue = false)]
        public LanguageDto Language { get; set; }

        /// <summary>
        /// Indicates if the terms of service are accepted by the user.
        /// </summary>
        /// <value>Indicates if the terms of service are accepted by the user.</value>
        [DataMember(Name = "areToSAccepted", EmitDefaultValue = true)]
        public bool AreToSAccepted { get; set; }

        /// <summary>
        /// The date and time of the latest activity of the user.
        /// </summary>
        /// <value>The date and time of the latest activity of the user.</value>
        [DataMember(Name = "latestActivity", EmitDefaultValue = true)]
        public DateTime? LatestActivity { get; set; }

        /// <summary>
        /// The disciplines associated with the user.
        /// </summary>
        /// <value>The disciplines associated with the user.</value>
        [DataMember(Name = "disciplines", EmitDefaultValue = false)]
        public List<DisciplineDto> Disciplines { get; set; }

        /// <summary>
        /// The organizations associated with the user.
        /// </summary>
        /// <value>The organizations associated with the user.</value>
        [DataMember(Name = "organizations", EmitDefaultValue = false)]
        public List<UserOrganizationDto> Organizations { get; set; }

        /// <summary>
        /// The institutes associated with the user.
        /// </summary>
        /// <value>The institutes associated with the user.</value>
        [DataMember(Name = "institutes", EmitDefaultValue = false)]
        public List<UserInstituteDto> Institutes { get; set; }

        /// <summary>
        /// The identity providers associated with the user.
        /// </summary>
        /// <value>The identity providers associated with the user.</value>
        [DataMember(Name = "identities", EmitDefaultValue = false)]
        public List<IdentityProviderDto> Identities { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class UserDto {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  GivenName: ").Append(GivenName).Append("\n");
            sb.Append("  FamilyName: ").Append(FamilyName).Append("\n");
            sb.Append("  Emails: ").Append(Emails).Append("\n");
            sb.Append("  Title: ").Append(Title).Append("\n");
            sb.Append("  Language: ").Append(Language).Append("\n");
            sb.Append("  AreToSAccepted: ").Append(AreToSAccepted).Append("\n");
            sb.Append("  LatestActivity: ").Append(LatestActivity).Append("\n");
            sb.Append("  Disciplines: ").Append(Disciplines).Append("\n");
            sb.Append("  Organizations: ").Append(Organizations).Append("\n");
            sb.Append("  Institutes: ").Append(Institutes).Append("\n");
            sb.Append("  Identities: ").Append(Identities).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserDto);
        }

        /// <summary>
        /// Returns true if UserDto instances are equal
        /// </summary>
        /// <param name="input">Instance of UserDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.DisplayName == input.DisplayName ||
                    (this.DisplayName != null &&
                    this.DisplayName.Equals(input.DisplayName))
                ) && 
                (
                    this.GivenName == input.GivenName ||
                    (this.GivenName != null &&
                    this.GivenName.Equals(input.GivenName))
                ) && 
                (
                    this.FamilyName == input.FamilyName ||
                    (this.FamilyName != null &&
                    this.FamilyName.Equals(input.FamilyName))
                ) && 
                (
                    this.Emails == input.Emails ||
                    this.Emails != null &&
                    input.Emails != null &&
                    this.Emails.SequenceEqual(input.Emails)
                ) && 
                (
                    this.Title == input.Title ||
                    (this.Title != null &&
                    this.Title.Equals(input.Title))
                ) && 
                (
                    this.Language == input.Language ||
                    (this.Language != null &&
                    this.Language.Equals(input.Language))
                ) && 
                (
                    this.AreToSAccepted == input.AreToSAccepted ||
                    this.AreToSAccepted.Equals(input.AreToSAccepted)
                ) && 
                (
                    this.LatestActivity == input.LatestActivity ||
                    (this.LatestActivity != null &&
                    this.LatestActivity.Equals(input.LatestActivity))
                ) && 
                (
                    this.Disciplines == input.Disciplines ||
                    this.Disciplines != null &&
                    input.Disciplines != null &&
                    this.Disciplines.SequenceEqual(input.Disciplines)
                ) && 
                (
                    this.Organizations == input.Organizations ||
                    this.Organizations != null &&
                    input.Organizations != null &&
                    this.Organizations.SequenceEqual(input.Organizations)
                ) && 
                (
                    this.Institutes == input.Institutes ||
                    this.Institutes != null &&
                    input.Institutes != null &&
                    this.Institutes.SequenceEqual(input.Institutes)
                ) && 
                (
                    this.Identities == input.Identities ||
                    this.Identities != null &&
                    input.Identities != null &&
                    this.Identities.SequenceEqual(input.Identities)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                {
                    hashCode = (hashCode * 59) + this.Id.GetHashCode();
                }
                if (this.DisplayName != null)
                {
                    hashCode = (hashCode * 59) + this.DisplayName.GetHashCode();
                }
                if (this.GivenName != null)
                {
                    hashCode = (hashCode * 59) + this.GivenName.GetHashCode();
                }
                if (this.FamilyName != null)
                {
                    hashCode = (hashCode * 59) + this.FamilyName.GetHashCode();
                }
                if (this.Emails != null)
                {
                    hashCode = (hashCode * 59) + this.Emails.GetHashCode();
                }
                if (this.Title != null)
                {
                    hashCode = (hashCode * 59) + this.Title.GetHashCode();
                }
                if (this.Language != null)
                {
                    hashCode = (hashCode * 59) + this.Language.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.AreToSAccepted.GetHashCode();
                if (this.LatestActivity != null)
                {
                    hashCode = (hashCode * 59) + this.LatestActivity.GetHashCode();
                }
                if (this.Disciplines != null)
                {
                    hashCode = (hashCode * 59) + this.Disciplines.GetHashCode();
                }
                if (this.Organizations != null)
                {
                    hashCode = (hashCode * 59) + this.Organizations.GetHashCode();
                }
                if (this.Institutes != null)
                {
                    hashCode = (hashCode * 59) + this.Institutes.GetHashCode();
                }
                if (this.Identities != null)
                {
                    hashCode = (hashCode * 59) + this.Identities.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
