/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a Data Transfer Object (DTO) for user-related organization information, inheriting from OrganizationDto.
    /// </summary>
    [DataContract(Name = "UserOrganizationDto")]
    public partial class UserOrganizationDto : IEquatable<UserOrganizationDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserOrganizationDto" /> class.
        /// </summary>
        /// <param name="uri">The ROR (Research Organization Registry) ID of the organization..</param>
        /// <param name="displayName">The display name of the organization..</param>
        /// <param name="email">The email address of the organization..</param>
        /// <param name="publicationAdvisoryService">publicationAdvisoryService.</param>
        /// <param name="varReadOnly">Determines if the organization&#39;s details can be modified..</param>
        public UserOrganizationDto(string uri = default(string), string displayName = default(string), string email = default(string), PublicationAdvisoryServiceDto publicationAdvisoryService = default(PublicationAdvisoryServiceDto), bool varReadOnly = default(bool))
        {
            this.Uri = uri;
            this.DisplayName = displayName;
            this.Email = email;
            this.PublicationAdvisoryService = publicationAdvisoryService;
            this.VarReadOnly = varReadOnly;
        }

        /// <summary>
        /// The ROR (Research Organization Registry) ID of the organization.
        /// </summary>
        /// <value>The ROR (Research Organization Registry) ID of the organization.</value>
        [DataMember(Name = "uri", EmitDefaultValue = false)]
        public string Uri { get; set; }

        /// <summary>
        /// The display name of the organization.
        /// </summary>
        /// <value>The display name of the organization.</value>
        [DataMember(Name = "displayName", EmitDefaultValue = false)]
        public string DisplayName { get; set; }

        /// <summary>
        /// The email address of the organization.
        /// </summary>
        /// <value>The email address of the organization.</value>
        [DataMember(Name = "email", EmitDefaultValue = true)]
        public string Email { get; set; }

        /// <summary>
        /// Gets or Sets PublicationAdvisoryService
        /// </summary>
        [DataMember(Name = "publicationAdvisoryService", EmitDefaultValue = false)]
        public PublicationAdvisoryServiceDto PublicationAdvisoryService { get; set; }

        /// <summary>
        /// Determines if the organization&#39;s details can be modified.
        /// </summary>
        /// <value>Determines if the organization&#39;s details can be modified.</value>
        [DataMember(Name = "readOnly", EmitDefaultValue = true)]
        public bool VarReadOnly { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class UserOrganizationDto {\n");
            sb.Append("  Uri: ").Append(Uri).Append("\n");
            sb.Append("  DisplayName: ").Append(DisplayName).Append("\n");
            sb.Append("  Email: ").Append(Email).Append("\n");
            sb.Append("  PublicationAdvisoryService: ").Append(PublicationAdvisoryService).Append("\n");
            sb.Append("  VarReadOnly: ").Append(VarReadOnly).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserOrganizationDto);
        }

        /// <summary>
        /// Returns true if UserOrganizationDto instances are equal
        /// </summary>
        /// <param name="input">Instance of UserOrganizationDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserOrganizationDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.Uri == input.Uri ||
                    (this.Uri != null &&
                    this.Uri.Equals(input.Uri))
                ) && 
                (
                    this.DisplayName == input.DisplayName ||
                    (this.DisplayName != null &&
                    this.DisplayName.Equals(input.DisplayName))
                ) && 
                (
                    this.Email == input.Email ||
                    (this.Email != null &&
                    this.Email.Equals(input.Email))
                ) && 
                (
                    this.PublicationAdvisoryService == input.PublicationAdvisoryService ||
                    (this.PublicationAdvisoryService != null &&
                    this.PublicationAdvisoryService.Equals(input.PublicationAdvisoryService))
                ) && 
                (
                    this.VarReadOnly == input.VarReadOnly ||
                    this.VarReadOnly.Equals(input.VarReadOnly)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Uri != null)
                {
                    hashCode = (hashCode * 59) + this.Uri.GetHashCode();
                }
                if (this.DisplayName != null)
                {
                    hashCode = (hashCode * 59) + this.DisplayName.GetHashCode();
                }
                if (this.Email != null)
                {
                    hashCode = (hashCode * 59) + this.Email.GetHashCode();
                }
                if (this.PublicationAdvisoryService != null)
                {
                    hashCode = (hashCode * 59) + this.PublicationAdvisoryService.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.VarReadOnly.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
