/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for accepting the terms of service by a user.
    /// </summary>
    [DataContract(Name = "UserTermsOfServiceAcceptDto")]
    public partial class UserTermsOfServiceAcceptDto : IEquatable<UserTermsOfServiceAcceptDto>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="UserTermsOfServiceAcceptDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected UserTermsOfServiceAcceptDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="UserTermsOfServiceAcceptDto" /> class.
        /// </summary>
        /// <param name="varVersion">The version of the terms of service being accepted. (required).</param>
        public UserTermsOfServiceAcceptDto(string varVersion = default(string))
        {
            // to ensure "varVersion" is required (not null)
            if (varVersion == null)
            {
                throw new ArgumentNullException("varVersion is a required property for UserTermsOfServiceAcceptDto and cannot be null");
            }
            this.VarVersion = varVersion;
        }

        /// <summary>
        /// The version of the terms of service being accepted.
        /// </summary>
        /// <value>The version of the terms of service being accepted.</value>
        [DataMember(Name = "version", IsRequired = true, EmitDefaultValue = true)]
        public string VarVersion { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class UserTermsOfServiceAcceptDto {\n");
            sb.Append("  VarVersion: ").Append(VarVersion).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as UserTermsOfServiceAcceptDto);
        }

        /// <summary>
        /// Returns true if UserTermsOfServiceAcceptDto instances are equal
        /// </summary>
        /// <param name="input">Instance of UserTermsOfServiceAcceptDto to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(UserTermsOfServiceAcceptDto input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.VarVersion == input.VarVersion ||
                    (this.VarVersion != null &&
                    this.VarVersion.Equals(input.VarVersion))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.VarVersion != null)
                {
                    hashCode = (hashCode * 59) + this.VarVersion.GetHashCode();
                }
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // VarVersion (string) minLength
            if (this.VarVersion != null && this.VarVersion.Length < 1)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for VarVersion, length must be greater than 1.", new [] { "VarVersion" });
            }

            yield break;
        }
    }

}
